package com.bzd.web.controller.bbfx;

import com.bzd.common.utils.DateUtils;
import org.bouncycastle.crypto.digests.SM3Digest;

import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;

public class SM3Example {

    public static void main(String[] args) {
        // 定义日期时间格式
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

        // 指定的时间字符串
        String dateStr = DateUtils.getTime();
        System.out.println("dateStr: " + dateStr);
        // 将字符串解析为LocalDateTime
        LocalDateTime localDateTime = LocalDateTime.parse(dateStr, formatter);

        // 转换为ZonedDateTime，这里假设时区为系统默认时区
        ZonedDateTime zonedDateTime = localDateTime.atZone(ZoneId.systemDefault());

        // 获取时间戳
        long timestamp = zonedDateTime.toInstant().toEpochMilli();
        System.out.println("timestamp: " + timestamp);
        // 示例消息
        String message = "宝智达_"+timestamp+"_8DEE0C919D045B43DE17080181D30";

        // 计算SM3哈希值
        //byte[] hash = sm3Hash(message);
       String hash= EncryptUtils.sm3(message);
        // 将哈希值转换为十六进制字符串
        //String hexString = new String(Hex.encode(hash));
        // 将十六进制字符串中的字母转为大写
        String upperCaseHexString = hash.toUpperCase();
        System.out.println("Message: " + message);
        System.out.println("SM3 upperCaseHexString: " + upperCaseHexString);
    }

    /**
     * 计算SM3哈希值
     *
     * @param input 输入的消息
     * @return SM3哈希值
     */
    public static byte[] sm3Hash(String input) {
        SM3Digest digest = new SM3Digest();
        byte[] bytes = input.getBytes();

        // 更新摘要
        digest.update(bytes, 0, bytes.length);

        // 计算哈希值
        byte[] hash = new byte[digest.getDigestSize()];
        digest.doFinal(hash, 0);

        return hash;
    }
}