package com.bzd.web.controller.jkgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.common.utils.ServletUtils;
import com.bzd.common.utils.StringUtils;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 慢病患者管理
 * creator wsp
 */
@Controller
@RequestMapping("/jkgl/mbhzServers")
public class SjkglmbhzController extends BaseController {

    // 档案馆
    private String prefix= "jkgl";
    @Autowired
    private PharmaceuticalService pharmaceuticalService;
    /**
     * 档案管理页
     *
     * @return
     */
    @RequiresPermissions("jkgl:bmhz:view")
    @GetMapping("/archivesmbhzList")
    public String archives() {
        return prefix + "/archivesmbhzList";
    }

    /**
     * 档案管理数据查询
     *
     * @return
     * @throws Exception
     */
    @RequiresPermissions("jkgl:bmhz:view")
    @PostMapping("/archivesmbhzList")
    @ResponseBody
    public TableDataInfo archivesList() throws Exception {
        PageData pd = this.getPageData();
        startPage();
        List<PageData> pageData = pharmaceuticalService.findArchivesList(pd);
        return getDataTable(pageData);
    }


}
