package com.bzd.system.service.gxhpz;

import com.bzd.common.config.dao.DaoBase;
import com.bzd.common.config.dao.DaoSupport;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.utils.DateUtils;
import com.bzd.common.utils.StringUtils;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import static com.bzd.common.utils.ShiroUtils.getSysUser;

@Service
public class DrugConfigService {
    @Autowired
    private DaoBase dao;

    @Resource(name = "daoSupport")
    private DaoSupport daoSupport;

    /**
     * 查询列表
     * @param pd
     * @return
     * @throws Exception
     */
    public List<PageData> findForList(final PageData pd) throws Exception {
        return (List<PageData>) daoSupport.findForList("drugConfigMapper.selectDrugConfig", pd);
    }
    public List<PageData> selectproductByCodeAndName(final PageData pd) throws Exception {
        return    (List<PageData>) daoSupport.findForList("drugConfigMapper.selectproductByCodeAndName", pd);
    }
    public PageData selectOneproductByCodeAndName(final PageData pd) throws Exception {
        return    (PageData) daoSupport.findForObject("drugConfigMapper.selectOneproductByCodeAndName", pd);
    }

    /**
     * 查询单个
     * @param pd
     * @return
     * @throws Exception
     */
    public Object findOne(final PageData pd) throws Exception {
        return daoSupport.findForObject("drugConfigMapper.selectOne", pd);
    }

    /**
     * 添加
     * @param pd
     * @return
     * @throws Exception
     */
    @Transactional(rollbackFor = Exception.class)
    public int save(final PageData pd) throws Exception {
        pd.put("createdBy", getSysUser().getUserId());
        pd.put("createdTime", DateUtils.getTime());

        return daoSupport.save("drugConfigMapper.addDrugConfig", pd);
    }

    /**
     * 删除
     * @param ids
     * @return
     * @throws Exception
     */
    public Integer del(List<String> ids) throws Exception {
        return daoSupport.delete("drugConfigMapper.deleteDrugConfigsByIds", ids);
    }

    /**
     * 修改
     * @param pd
     * @return
     * @throws Exception
     */
    public Integer update(PageData pd) throws Exception {
        String type = (String) pd.get("type");
        if(type.equals("1")){
            int result1=0;
            String dValueId = (String) pd.get("dValueId");
            String dValueName = (String) pd.get("dValueName");
            Object drugData =pd.get("drugData");
            if(StringUtils.isNotNull(drugData)){
                try {
                    // 将 JSON 字符串转换为 List<Map<String, Object>>
                    ObjectMapper objectMapper = new ObjectMapper();
                    List<Map<String, Object>> rowsList = objectMapper.readValue(drugData.toString(), List.class);
                    // 遍历列表并调用插入数据接口
                    for (Map<String, Object> hbs : rowsList) {
                        PageData pd4=new PageData();
                        pd4.put("d_value_code", dValueId);
                        pd4.put("dValueName", dValueName);
                        pd4.put("mdmCode", hbs.get("mdmCode"));
                        pd4.put("dvalueStatus", pd.get("saveStatus"));
//                        pd4.put("specification", hbs.get("specification"));
//                        pd4.put("manufacturerShortName", hbs.get("manufacturerShortName"));
//                        pd4.put("isFollowUpManaged", hbs.get("isFollowUpManaged"));
//                        pd4.put("isColdChainManaged", hbs.get("isColdChainManaged"));
//                        pd4.put("isRegisteredManaged", hbs.get("isRegisteredManaged"));
//                        pd4.put("isCharityAidManaged", hbs.get("isCharityAidManaged"));
//                        pd4.put("administrationMethod", hbs.get("administrationMethod"));
//                        pd4.put("dosageAndAdministration", hbs.get("dosageAndAdministration"));
//                        pd4.put("enterpriseFlowManagement", hbs.get("enterpriseFlowManagement"));
                        //pd4.put("createdBy", pd.get("createdBy"));
                        //pd4.put("createdTime", pd.get("createdTime"));
                        pd4.put("dvupdatedby", getSysUser().getUserId());
                        pd4.put("dvcreatedTime", DateUtils.getTime());
                        pd4.put("remarks", pd.get("remarks"));
                        result1 = daoSupport.update("drugConfigMapper.updateDrugConfig2", pd4);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            if(result1>0 ){
                return 1;
            }else{
                return 0;
            }
        }else{
            pd.put("updatedBy", getSysUser().getUserId());
            pd.put("updatedTime", DateUtils.getTime());
            return daoSupport.update("drugConfigMapper.updateDrugConfig", pd);

        }
    }

    /**
     * 启用停用配置
     * @param pd
     * @return
     * @throws Exception
     */
    public Integer changeStatus(PageData pd) throws Exception {
        pd.put("updatedTime", DateUtils.getTime());
        pd.put("updatedBy", getSysUser().getUserId());
        return daoSupport.update("drugConfigMapper.changeStatus", pd);
    }
    /**配置药查询**/
    public List<PageData> getAllDrugs(final PageData pd) throws Exception {
        return (List<PageData>) daoSupport.findForList("drugConfigMapper.getAllDrugConfig", pd);
    }
    /**
     * 启用停用D值配关联
     * @param pd
     * @return
     * @throws Exception
     */
    public Integer changedvalueStatus(PageData pd) throws Exception {
        pd.put("updatedTime", DateUtils.getTime());
        pd.put("updatedBy", getSysUser().getUserId());
        return daoSupport.update("drugConfigMapper.changedvalueStatus", pd);
    }

}
